#
# $Id: Makefile.inc,v 1.10 2003/11/12 23:26:21 markus Exp $
#
# Common rules for {n,p,g}make
#

####### Compile

main.o: main.cpp MainForm.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)main.o main.cpp

MainForm.o: MainForm.cpp MainForm.hpp QMemoryTable.hpp QMemoryPane.hpp \
	Options.hpp QDebugPane.hpp QDisassemblerPane.hpp \
	QAssemblerOut.hpp QAboutDialog.hpp QHelpWindow.hpp \
	QStackTable.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)MainForm.o MainForm.cpp

MainForm_moc.o: MainForm_moc.cpp MainForm.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)MainForm_moc.o MainForm_moc.cpp

MainForm_moc.cpp: MainForm.hpp
	$(MOC) MainForm.hpp -o MainForm_moc.cpp

# following this mark everything is commented

QMemoryPane.o: QMemoryPane.cpp QMemoryPane.hpp QMemoryTable.hpp \
		QHexLineEdit.hpp ../interpreter/Memory.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QMemoryPane.o QMemoryPane.cpp

QMemoryPane_moc.o: QMemoryPane_moc.cpp QMemoryPane.hpp \
		../interpreter/Memory.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QMemoryPane_moc.o QMemoryPane_moc.cpp

QMemoryPane_moc.cpp: QMemoryPane.hpp ../interpreter/Memory.hpp
	$(MOC) QMemoryPane.hpp -o QMemoryPane_moc.cpp

QMemoryTable.o: QMemoryTable.cpp QMemoryTable.hpp \
		../interpreter/MemoryChain.hpp ../interpreter/Memory.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QMemoryTable.o QMemoryTable.cpp

QMemoryTable_moc.o: QMemoryTable_moc.cpp QMemoryTable.hpp \
		../interpreter/MemoryChain.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QMemoryTable_moc.o \
		QMemoryTable_moc.cpp

QMemoryTable_moc.cpp: QMemoryTable.hpp ../interpreter/Memory.hpp
	$(MOC) QMemoryTable.hpp -o QMemoryTable_moc.cpp

QHexIntValidator.o: QHexIntValidator.cpp QHexIntValidator.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QHexIntValidator.o \
		QHexIntValidator.cpp

QDecIntValidator.o: QDecIntValidator.cpp QDecIntValidator.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QDecIntValidator.o \
		QDecIntValidator.cpp

QHexLineEdit.o: QHexLineEdit.cpp QHexLineEdit.hpp QHexIntValidator.hpp \
		QDecIntValidator.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QHexLineEdit.o QHexLineEdit.cpp

QHexLineEdit_moc.o: QHexLineEdit_moc.cpp QHexLineEdit.hpp \
		QHexIntValidator.hpp QDecIntValidator.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QHexLineEdit_moc.o \
		QHexLineEdit_moc.cpp

QHexLineEdit_moc.cpp: QHexLineEdit.hpp
	$(MOC) QHexLineEdit.hpp -o QHexLineEdit_moc.cpp

QDisassemblerPane.o: QDisassemblerPane.cpp QDisassemblerPane.hpp \
		../interpreter/MemoryChain.hpp ../interpreter/CPU.hpp \
		../interpreter/Decoder.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QDisassemblerPane.o QDisassemblerPane.cpp

QDisassemblerPane_moc.o: QDisassemblerPane_moc.cpp QDisassemblerPane.hpp \
		../interpreter/Memory.hpp ../interpreter/CPU.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QDisassemblerPane_moc.o QDisassemblerPane_moc.cpp

QDisassemblerPane_moc.cpp: QDisassemblerPane.hpp
	$(MOC) QDisassemblerPane.hpp -o QDisassemblerPane_moc.cpp

QDebugPane.o: QDebugPane.cpp QDebugPane.hpp QDialogAddress.hpp\
		../interpreter/CPU.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QDebugPane.o QDebugPane.cpp

QDebugPane_moc.o: QDebugPane_moc.cpp QDebugPane.hpp \
		../interpreter/CPU.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QDebugPane_moc.o QDebugPane_moc.cpp

QDebugPane_moc.cpp: QDebugPane.hpp
	$(MOC) QDebugPane.hpp -o QDebugPane_moc.cpp

QDialogAddress.o: QDialogAddress.cpp QDialogAddress.hpp \
		QHexIntValidator.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QDialogAddress.o QDialogAddress.cpp

QDialogAddress_moc.o: QDialogAddress_moc.cpp QDialogAddress.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QDialogAddress_moc.o QDialogAddress_moc.cpp

QDialogAddress_moc.cpp: QDialogAddress.hpp
	$(MOC) QDialogAddress.hpp -o QDialogAddress_moc.cpp

Options.o: Options.cpp Options.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)Options.o Options.cpp

Options_moc.o: Options_moc.cpp Options.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)Options_moc.o Options_moc.cpp

Options_moc.cpp: Options.hpp
	$(MOC) Options.hpp -o Options_moc.cpp

QAssemblerOut.o: QAssemblerOut.cpp QAssemblerOut.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QAssemblerOut.o QAssemblerOut.cpp

QAssemblerOut_moc.o: QAssemblerOut_moc.cpp QAssemblerOut.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QAssemblerOut_moc.o QAssemblerOut_moc.cpp

QAssemblerOut_moc.cpp: QAssemblerOut.hpp
	$(MOC) QAssemblerOut.hpp -o QAssemblerOut_moc.cpp

QAboutDialog.o: QAboutDialog.cpp QAboutDialog.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QAboutDialog.o QAboutDialog.cpp

QAboutDialog_moc.o: QAboutDialog_moc.cpp QAboutDialog.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QAboutDialog_moc.o QAboutDialog_moc.cpp

QAboutDialog_moc.cpp: QAboutDialog.hpp
	$(MOC) QAboutDialog.hpp -o QAboutDialog_moc.cpp

QHelpWindow.o: QHelpWindow.cpp QHelpWindow.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QHelpWindow.o QHelpWindow.cpp

QHelpWindow_moc.o: QHelpWindow_moc.cpp QHelpWindow.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QHelpWindow_moc.o QHelpWindow_moc.cpp

QHelpWindow_moc.cpp: QHelpWindow.hpp
	$(MOC) QHelpWindow.hpp -o QHelpWindow_moc.cpp

QStackTable.o: QStackTable.cpp QStackTable.hpp \
		../interpreter/MemoryChain.hpp ../interpreter/Memory.hpp \
		../interpreter/CPU.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QStackTable.o QStackTable.cpp

QStackTable_moc.o: QStackTable_moc.cpp QStackTable.hpp \
		../interpreter/MemoryChain.hpp \
		../interpreter/CPU.hpp
	$(CC) -c $(CFLAGS) $(INCPATH) $(OBJOUT)QStackTable_moc.o \
		QStackTable_moc.cpp

QStackTable_moc.cpp: QStackTable.hpp ../interpreter/Memory.hpp
	$(MOC) QStackTable.hpp -o QStackTable_moc.cpp



