/* $Id: QAboutDialog.cpp,v 1.2 2003/12/12 09:47:26 markus Exp $ */

/*
 * Copyright (c) 2003 Markus Hennecke
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the Author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * The implementation of the about dialog...
 */

// program includes:
#include "QAboutDialog.hpp"

// sytem includes:
#include <qvariant.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>

namespace GUI {

  static const char * const image0_data[] = { 
    "110 85 8 1",
    "a c #b2b1b2",
    "# c #bcbdbc",
    ". c #c5c3c5",
    "b c #d0d0d0",
    "d c #d9dad9",
    "c c #e7e6e7",
    "f c #f2f2f2",
    "e c #fcfdfc",
    ".#.#.#.#.#.#.#.#.#.#.#.#.....#.#.##..#...ab#.##.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.",
    "#.#.#.#.#.#.#.#.#.#.#.#.#####.#.#..aab.a#ba..#.a.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#",
    ".#.#.#.#.#.#.#.#.#.#.#.#..#.##..#..b.####ba##.b..#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#",
    "#.#.#.#.#.#.#.#.#.#.##.##...###...bcd##b.#.#.ecf#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.",
    ".##.##.#.#.#.#.#.#.#.#.#....###.bddddb####b.defc.##.##.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#",
    "#.#.#.#.#.#.#.#.#.##.#.###.###.bfd.bbb###..bfbc.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.##.##.",
    ".#.#.#.#.#.#.#.#.#.#.##.#.##.bdcf.#dda#bdcdcfdd##.##.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#",
    "#.#.#.#.#.#.#.#.#.#.#.#.#..#.dfe.bdd.#.bcdcddd#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.",
    ".##.##.#.#.#.#.#.#.#.#.#.#.bbef##bd##.be.bfdd.b###.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#",
    "#.#.#.#.#.#.#.#.#.##.#.#.##dee..dd#.#bedbcddbb###.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.##.##.",
    ".#.#.#.#.#.#.#.#.#.#.#.#.#dfec#bdb##dec.dcdd#b#..#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#",
    "#.#.#.#.#.#.##.##.#.#.#..#eec.dd##.bee#bcddb.##.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.",
    ".#.#.##.##.#.#.#.#.#.#.#.ded.#c.#bacebbfddb###.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#",
    "#.#.#.#.#.#.#.##.#.#.#.#bec#.bd#.#dec.cedd#b#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.##.##.#.#.",
    ".#.#.#.#.#.#.#..#.#.#.#.ce..ddb#b#eebffdcb###.##.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#",
    "#.#.#.#.#.#.#.##.#.#.#.#eb.fdbb#.eecdfe.c.bab#.##.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.",
    ".#.#.#.#.##.#.#..#.##.#fe#cf.c##fff.eef#db####....#...######..###..####a.#..#########.##.#.#.#.#.#.#.#.#.#.#.#",
    "#.#.#.#.#..#.#.#.#.##.bec#ff#c#defbbeecdd.#..##..#.###......##..####...b#####..b...#.####.#.#.#.#.##.##.#.#.#.",
    "##.#.#.#.##.#.#.###...cec.ecbdbeed#deedc.##..##.##...###a#.#####...#####.....##a###.##..#.##.#.#.#.#.#.#.#.#.#",
    "#.#.#.#.#..#.#.#..#.#beecdebc.fef.#eecbd.###.##.....###b.dcdddddddbbb.######..#.##.##.#.#.#.#.#.#.#.#.#.#.#.#.",
    ".#.#.#.#.##.#.#.#.#..beeded.dbeef.defdcb#...###...###bdffeeeeeeeeeeeeeefddb##...#....#.#.#.#.#.#.#.#.#.#.#.#.#",
    "#.#.#.#.#..#.#.#..##bceece.ddfefdbeecdc#..#.###.a#.bcfeeeeeefeeefffeeefeefffdb.#####...##.#.#.#.##.##.#.#.#.#.",
    ".#.#.#.#.##.#.#.#..#beeeff.cceed.ceecdba.#.##.#.#bceeeeeeeeeeeeeeeeeeeeeffeeeecdb####...#.##.#.#.#.#.#.#.#.#.#",
    "#.#.#.#.#..#.#.##..adeeeebddeec.beefbc#.####..##cfeeeeeedceeefffeffeeeeeeeffeeeefdb##.###.#.#.#.#.#.#.#.#.#.#.",
    "##.#.#.#.#..#.#..#..feeef.dced#beeebf.#..##.##bceefeeeeeeeefeeeecbceeeeeeecfccceeeecb#ab##.###.##.#.#.#.#.#.##",
    "#.#.#.#.#####.###...eeeebbfeedbcfeccdba.#..a.deeeeeeeeeeefcceffccceeeeeeceeeefcdffeeffb###.#..###.#.#.#.#.#.#.",
    ".#.#.#.#....##..#.#dfeeedceecbcfcedc#bab.##bcfeeeeeeeeeeeeeeeefeefeecdddeeefcfeedcefeecdb.##...#.#.#.#.#.#.#.#",
    "##.#.#.#..##...#..#feefeffeedafefcdb#a##..bfeeefeeffeffcbddffeeeeffcdccecdddfcffffeccffedb####..#.#.#.#.#.#.#.",
    ".#.#.#.##.##.#.#.#.eeeeeceefbdeeebd##ad#bceeeeedeefeefeeefcececbfcb.bccfb.cfeffdefeecddfefdd.##..#.#.#.#.#.#.#",
    "#.#.#.#.#.#.b#b###beeeeefeed.fefcbbbbdfcfeeeeeefeeeefceeeeeeffeeeccbdfddcfeccfeffcceecdceeefc.###.#.#.#.#.#.##",
    ".#.#.#.##b#bd.d..bfeeeeffefdbefcdddffeeeeeeeeeeefeeec.dcdcef.#ddbbb#dd.bbccb.ccdbbdfeefeeeeeecd..#.#.#.#.#.#.#",
    "##.#.#.##.#bd.d#dceeeeecdccccebfcfeeeeeeeeeffeeccffefcffdbdb#.cc.bb.bb#bbb#.#db.#bccccdccfeeeeec#.#.#.#.#.#.#.",
    ".##..##.##c.#dbcfeeeeeefcbbfcefeeffeefefeecbceeeeefeccedcbbc..c..dd.dccdded.bb#b.#..##bdfdbfefeeb##b##.###.#.#",
    "##.#.##.#b#b..ceeeefefcb#..feee.bdceeeeefeefeffeecffccccefffcdfcbccb.bbddcb.cdbb.#.#.#.bbbbfeeeec.#.##..#.#.#.",
    ".##..#...d#bdbeefeef.#.dfebcddbacdbeeeccdeeeeeeccdebceeeccddb.dbcffcccccdb#.d.a..#..###.#.#bdfeeeb####...#.#.#",
    ".##.##..#bd.bfeeeecd.#..bcbdc.dcdccffedebeeefeeb.cc.dcb..ba##a.#..#bddbb#a####...###.#.#..#a.deeed##...##.#.##",
    "#.#..#.b#..bdeefefcb.#a#..bbdd.bdccdeececceecbfcdcdffb#.#.##....###.b###b..##..a...#..#.##....ceec.#..##.#.#.#",
    ".##.###b..#cefeeeeefdb.b###abcdbfdf.eedddceeb.fcddabb##.a.##.####..#aa#b#.bddcfdbb.###.#.#..#.deeed##.#.#.#.#.",
    ".#..#..bbbbeefeed.##bb#a.bd..bc..bebcebcfcec#cebcfbaa...#.#..####..#.bcfeeefddbd..b##.##ba.###bffec###.#.#.#.#",
    ".###.#..b.eeeebdb.####..fc.#.afdbbe.deddebecbeecbabab.#...#.##b##.##dfeeec.#.##.#..##..###..#.a.cef...###.#.#.",
    "#...#.##dceeed.d.dc..#ffdb#.#.bc#.fbde.bccebc.b####..##.##.#.###.##ceeec.#.dccfeffeccdb#.###..##dfeb#.#.#.#.##",
    ".#.#.#.#beeeedccfb.##fe.b.#....b.bf.cfbcccf..a.#..#.#...dddb....#.cefd#.ceefeeeeeeeffffcdb..#..#dfec##.##.#.#.",
    "#.#.#.#.beeeddcdb#b#bed.###..##.#bd.fc.cdb.#...###.bddddbdfeffdd#.efcddfeeeeeeeeeecd..b#db####..bfef#....#.#.#",
    ".#.#.#.#ceef#fdcfcdacedb####.##..bb#fc.f.b#.#b..bbddd..#dfefccfcb#fddceeefcfcccfdd.#####.###.###bdee##.#.#.#.#",
    "#.#.#.#.ffeedfceebc#dec#.###.#...bbbecbe.b..a##.bbdcffcfceefccccebfdcfffeefb#.#a...##..b##.....##bfe...##.#.#.",
    ".#.#.#.#feeeebeefdebeecb###...##.d.dedde..a##b..bbb.####bdfeeefefabfcddcb.#a#.b..#.######.####.##bfed#.#.#.#.#",
    "#.#.#.#.feeee.ceeebaeeba#.#.##.##b.dfbce..#bbd.#.#####..###.bdfeebceefeedb#b.#a####...#..######.#.ffc##.#.#.#.",
    ".#.#.#.#eeeeefbecdbceefb..####..#b#df.ce#dffd##..#...#.#b##..#dccddecfc#.##a#.b#.##.###.##...#.#..fce..#.#.#.#",
    "#..#..#.eeedec.b#bcfbbb###....###.ceb.e..cd##.#.#.#.#.#..###..#cdccf.cd##.#.####.#.#..#.#.#.#.###.fbeb#.#.#.#.",
    ".#.#.#.#feedef..#cef#a..##.###..cbcfbdfbbbb##.##.#.#.#.#.#..#.#cdccfbfc#.#.#.#..#.#.##.#.#.#.#....cbeb...#.#.#",
    "#.#.#.#.eefbffb#beedb..#.##.##.dd.ddbcdc.....##.#.#.#.####.##..dffcecec.#.#.#.##.#.#..#.#.#.#.##..c.eb.##.#.#.",
    ".#.#.#.#efb#ff.#beeec#a#.##..#bc.bfbbddc..#b.#...#.##.#.##b##.#dffcecfd#.#.#.#..#.#.##.#.#.#.#.#.#d#ed.#.#.#.#",
    "#.###.#.ec..cd.##bceefbb#.##..bd.dfbcbdb#b.###.##.#..#.##..##b#.fcdfdc###.#.#.##.#.#..#.#.#.#.#...b.fc..#.#.#.",
    "#.#.#...eeb.bbbdbbbbcefd.#.##.bb.cdbedc##fd###.#.#.#.#.#.###..#befdecd#.#.##.#..#.#.##.#.#.#.#.#..b.cc.#.#.#.#",
    "##.#...bff##bcefdcfd..bd#.#.bbb#bc.dfbd.beb#.#..#.#.#.#..#.#.#.decbeef#..#.#.#.#.#.#..#.#.#.#.#.#..#cc###.#.#.",
    ".##.#.bbee#.cefb#bfed.###..#bdb#de.fd.#bbe#ab##..#.#.#.#.#...#.fecbeef#.#.#.#.#.#.#.##.#.#.#.#.#.bb.fc.#.#.#.#",
    "##.##.##fe.deb.bb#beef..##....b.ebbf..#.bd.#.####..#####..#.##.cebbeeb..#..#...#......##.####.###db#ed.#.#.#.#",
    ".#.#.#..cf.de.###bcfeec..##..##.fbbfdbddfc.###...###..##cc..#.defbdeef.#.bcfeefc..###...#.#..#.##d.#edb#.#.#.#",
    "#.#.#...cfddc.b..bffeeec.##..#bccbddd.ddcd.#.##..##..#bcef.ab#ded#befb.beeefcfffcdb.###.#.#.#.#..d#.ed.#.#.#.#",
    ".#.#....bfff.#.b.deeefcdb...##bfcddb.#ddbd.....####.#.ceed##.#ffb.bcd.deeeefdb##b..#..#.##.#.#.#bb#bfb.###.#.#",
    "#..#....#defba.bdeedbffdb.#a#bccddc.##..bd##.#.#.###bceee.#..beb##..#.cefefdb#######.#.#...####.b.#bfb##.#.#.#",
    "#..#.#...#deeddfeccbceeecdbbcefdbbdb...##b#a######.dceeef##..de.bdcdbceeefd###..bb...#.####.##..b#.cf..#.#.#.#",
    "..#.#.#..#bfeffefbcfeefeeeffeec.#....bbb#d...#..#bcffeeed#.##ed..cfd.deefcdb#.#aa#a###..#..##..d##bfc#..#.#.#.",
    "...#######.#bddcfccdbbdfddfeeedb..##.dddfecb.bccfcceeeee##babe..dfd#.eecfd.##.........#####.#.bd.#dfc#.#.#.#.#",
    "##.#..#...####.#..b.....b#.deed..#.a.cb#beefeeeeceeeeefc#b##cf.#bc##deefdefa...###.##.#..###.bd##befb#bbdbd..a",
    "..#.##.##..#....bb#.bdb####bceecb....ddfcddeecceeeeeeed.###dfd#.#c..cefefef..##..#....#.##.dddb.#.ccdfffeffcb#",
    "##.#.#.###...#####.##.##..##.cfcba#####dfdceefeeeeeefd.#.#.ff.a.dfd.defecef#.a#...##.#.#.##db..#bdeeeecddcff..",
    "#..#.#.#...###..#...##.b#..##dcffbb.b##.bfeefeefeeffd##...dfd##bfec#beefbcf....##.#.#.##b#.dd.#.cfefefd.#bbd.#",
    "#.#.#.#..###......###..#######bcec.####.#ceeeeceefbb.##..dcd..bbffc.aeefddcddb.#####.#.#.#.db##.feefcd.#cddbb#",
    ".#.#.#.##.#...###..###.#..#.#a#bccb.##.#.feeefcecb####.bbccb##bbdddc#deefdcffb#..#..#..bd..#a#bdefed...dfdd##a",
    "#.#.#.#..#..##.bdcecdddfb..bdddceefffdccceeeeefc##.###bcfcd.bb...cbc.#feefcdcbb.#.b#.bbddb.#.ceefb.#abfeb.#a##",
    ".#.#.#.##.###bdeeeeeeeefeeccfeeeeecfefeeeeeeefd##.##.bbdfd#.ccbc.e...acfeef.#bd#.#b...dc####dfecbabfccb#.##.#b",
    "#.#.#.#.##...dfeeeeeeefcffeeeeeeefceccdcccfefcb.###.bdccda.dcceebdd.bbfffeeeed#dbb#..##.bbdefeedcffdb#.####.##",
    ".#.#.##.####.bdfeeeeeeeffceceeeeeefcdcffb..cd.###.bbdcdd.ddbdceffefdcefbeefeeefecdccccffeeeecfedddd.##.....##.",
    "#.#.#.#.#.####bbffffeefcddfdfeeeefddfd.abdcfcdb##.bcffccfdfeceeeeeefceeefceeffeeeeeeeeeecdb.#bf.b..##..###.#.#",
    "#.#.#.#.#...###.cfeeefffdcecfeeefddbb#bdffd.a##abbcfeeeefefeefcfddbfffcdfdcc#bffffdbb.##..a.dffb#.###.##..#.#.",
    "#.#.##.##....##.#dcfcccfcffeeeeeefc.b.ced.#...bcfffeeeeeeeeedff.beec#b#.#bdccdb#b..##..#b.bcefda##...#####.#.#",
    "#.#.#.#.##.#.##.#a#.bbb.cc.efeeeeeffeef###.cfefffffffffefecbfcbdecb##bb#.b##..#b...bdcfceefeedb.#..###....#.##",
    "#..#.#.###.##.##b.###..#..addccccfefceeeeeecfeeedbbdbbdcecceecfefccffdcfcffffcdeeeeeeeeccdb..a##.#####..#.#.#.",
    ".#.#.#.#...#.#.###..###.#b...#.#..ab##.ffb...b.b.....#a.ab..d.#.ddd....#.#.ddbbb.....b.##b#..#..##....##.#.#.#",
    "#.#.#.#.###.#.#.#.#.#.#####.#.#.#.#.#.###.#.##.#.#.#.#.#.#..#.#.#.#.##.###.#.####.#.######.#..#.#.#.#.#.#.#.#.",
    ".#.#.##.#..#.#.#.##.#.#..#.#.#.#.#.#.#.#.##.#.#.#.#.#.#.#.##.#.#.#.#..##..#.#...#.#.#....#.#.#.#.#.#.#.#.#.#.#",
    "#.#.#.#.###.#.#.#..#.#.##.#.#.#.#.#.#.#.#.#.#.#.##.#.#.#.#.#.#.#.#.#.#..##.#.##.#.#.#.##.#.#.##.#.#.#.#.#.#.#.",
    ".#.##.#.#..#.#.#.##.#.#..#.#.#.#.#.#.##.#.#.#.#.#.#.##.##.#.#.#.#.#.#.##..#.#..#.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#",
    "#.#.#.##.##.#.#.#..#.#.##.#.#.#.#.#.#.#.#.#.#.#.#.##.#.#.#.#.#.#.#.#.#..##.#.##.#.#.#.#.#.#.#.#.#.#.#.#.#.#.#."};



  QAboutDialog::QAboutDialog(QWidget* parent, const char* name,
                             bool modal, WFlags fl)
    : QDialog(parent, name, modal, fl),
      image0((const char **) image0_data)
  {
    if (!name)
      setName("QAboutDialog");
    QAboutDialogLayout = new QVBoxLayout(this, 11, 6, "QAboutDialogLayout"); 

    layout2 = new QHBoxLayout(0, 0, 6, "layout2"); 

    pixmapLabel1 = new QLabel(this, "pixmapLabel1");
    pixmapLabel1->setPixmap(image0);
    pixmapLabel1->setScaledContents(false);
    layout2->addWidget(pixmapLabel1);
    QSpacerItem* spacer = new QSpacerItem(161, 21, QSizePolicy::Expanding,
                                          QSizePolicy::Minimum);
    layout2->addItem(spacer);

    textLabel1 = new QLabel(this, "textLabel1");
    textLabel1->setMinimumSize(QSize(300, 0));
    textLabel1->setTextFormat(QLabel::RichText);
    layout2->addWidget(textLabel1);
    QAboutDialogLayout->addLayout(layout2);

    layout1 = new QHBoxLayout(0, 0, 6, "layout1"); 
    QSpacerItem* spacer_2 = new QSpacerItem(101, 21, QSizePolicy::Expanding,
                                            QSizePolicy::Minimum);
    layout1->addItem(spacer_2);

    okButton = new QPushButton(this, "okButton");
    layout1->addWidget(okButton);
    QSpacerItem* spacer_3 = new QSpacerItem(61, 20, QSizePolicy::Expanding,
                                            QSizePolicy::Minimum);
    layout1->addItem(spacer_3);
    QAboutDialogLayout->addLayout(layout1);
    languageChange();
    connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));
    resize(QSize(460, 237).expandedTo(minimumSizeHint()));
  }

  // QAboutDialog::~QAboutDialog()
  // Nothing to do here...
  QAboutDialog::~QAboutDialog()
  { }

  // void QAboutDialog::languageChange()
  // Sets the strings of the subwidgets using the current
  void QAboutDialog::languageChange()
  {
    setCaption(tr("HASI - About"));
    textLabel1->setText(trUtf8("HASI - <b>H</b>ypothetical Machinecode <b>A</b>ssember and <b>SI</b>mulator<br>\n"
                               VERSION"<br><br>\n"
                               "(c)2003 by Markus Hennecke<br>\n"
                               "Written for Fachhochschule S&uuml;dwestfalen"));
    okButton->setText(tr("&Ok"));
  }
}
