/* $Id: QAboutDialog.hpp,v 1.3 2004/11/21 20:54:24 markus Exp $ */

/*
 * Copyright (c) 2003 Markus Hennecke
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the Author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * The declaration of the about dialog...
 */

#ifndef HASI_QABOUTDIALOG_HPP
#define HASI_QABOUTDIALOG_HPP

// system includes:
#include <qvariant.h>
#include <qpixmap.h>
#include <qdialog.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QLabel;
class QPushButton;

#define VERSION "Version 1.1-pre2"

namespace GUI {

  /*
   * class QAboutDialog
   */
  class QAboutDialog : public QDialog
  {
    Q_OBJECT

  public:
    QAboutDialog(QWidget* parent = NULL, const char* name = NULL,
                 bool modal = false, WFlags fl = 0);
    ~QAboutDialog();

    QLabel      *pixmapLabel1;
    QLabel      *textLabel1;
    QPushButton *okButton;

  protected:
    QVBoxLayout *QAboutDialogLayout;
    QHBoxLayout *layout2;
    QHBoxLayout *layout1;

  protected slots:
    virtual void languageChange();

  private:
    QPixmap image0;

  };

}

#endif // HASI_QABOUTDIALOG_HPP
