/* $Id: QAssemblerOut.hpp,v 1.2 2003/12/12 09:47:26 markus Exp $ */

/*
 * Copyright (c) 2003 Markus Hennecke
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the Author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * Shows the output of the assembler in a widget. The output is splittet into
 * error messages and other messages.
 */
#ifndef HASI_QASSEMBLEROUTPUT_HPP
#define HASI_QASSEMBLEROUTPUT_HPP

// system includes:
#include <string>
#include <qvariant.h>
#include <qdialog.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QPushButton;
class QTextEdit;
class QSplitter;

namespace GUI {
  
  /*
   * class QAssemberOutput
   */
  class QAssemblerOutput : public QDialog
  {
    Q_OBJECT

  public:
    QAssemblerOutput(QWidget *parent = NULL, const char *name = NULL,
                     bool modal = true, WFlags fl = 0);
    ~QAssemblerOutput();

    QTextEdit   *messagesTextEdit;
    QTextEdit   *errorTextEdit;
    QSplitter   *splitter;
    QPushButton *dismissButton;
    QPushButton *debuggerButton;

  protected:
    QVBoxLayout *QAssemblerOutputLayout;
    QHBoxLayout *buttonLayout;

  protected slots:
    virtual void languageChange();

  public slots:
    virtual void addLine(const std::string &);
  };

}

#endif // HASI_QASSEMBLEROUTPUT_HPP
