/* $Id: QDialogAddress.hpp,v 1.3 2003/12/12 09:47:27 markus Exp $ */

/*
 * Copyright (c) 2003 Markus Hennecke
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the Author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef HASI_QDIALOGADDRESS_HPP
#define HASI_QDIALOGADDRESS_HPP

// system includes:
#include <string>

// qt includes:
#include <qpushbutton.h>
#include <qdialog.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qlineedit.h>

namespace GUI {

  /*
   * class QDialogAddress
   */
  class QDialogAddress : public QDialog
  {
    Q_OBJECT

  private:
    unsigned int address;
    std::string  comment;

    QLabel       *editAddressLabel;
    QLabel       *editCommentLabel;
    QPushButton  *okButton;
    QPushButton  *cancelButton;
    QHBoxLayout  *buttonHBox;
    QVBoxLayout  *topLayout;
    QGridLayout  *editGrid;
    QLineEdit    *editComment;
    QLineEdit    *editAddress;
    
  public:
    // Constructors / Destructor:
    QDialogAddress(const unsigned int address, const std::string &comment,
                   QWidget *parent = NULL, 
                   const char *name = "Edit Address Dialog",
                   bool modal = true, WFlags f = 0);
    virtual ~QDialogAddress();

    // functions to read the input made
    const std::string &getComment() const { return comment; }
    unsigned int getAddress() const { return address; }
    
  protected slots:
    void okPressed();
  };

}

#endif // HASI_QDIALOGADDRESS_HPP
